static char rcsid [] = "$Id: timer.cc,v 1.1 2001/08/07 22:10:50 suman Exp suman $";

/*
 * $Log: timer.cc,v $
 * Revision 1.1  2001/08/07 22:10:50  suman
 * Initial revision
 *
 */

/*
 * File: timer.cc
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */


#include <stdio.h>
#include <assert.h>
#include "scheduler.h"
#include "timer.h"

Timer::Timer(void) {

 id = timer_id_gen; 
 timer_id_gen ++; 
 is_set = false; 
};
 
Timer::~Timer (void) {

  CancelTimer();
}

void Timer::SetTimer (double rel_time) {

  assert (is_set == false);
  EventInfo *e = new EventInfo(EVENT_TIMER,(void*)this,NULL);
  pos = Scheduler::AddRelativeEvent(rel_time,e);
  is_set = true;
  return;
}

void Timer::CancelTimer (void) {

  if (is_set == true) {
    EventInfo *e = Scheduler::DeleteEvent(pos);
    assert (e->et == EVENT_TIMER);
    delete e;
    is_set = false;
  }
  return;
}

void Timer::Handler (void) {

  is_set = false;
  EventHandler();
  return;
}

/* SHOULD BE A VIRTUAL FUNCTION : DONT DEFINE IT
void Timer::EventHandler (void) {

  printf ("this is a problem\n");
  return;
}
*/
