/*
 * File: packet.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */

#ifndef _PACKET_H_
#define _PACKET_H_

#define CONSTANT_LINK_DELAY 0.001 // All time info is in secs

enum PacketType {
  PACKET_NONE,
  PACKET_ROUTING,
  PACKET_APP
};

class Packet {

public :

  PacketType t;
  int id; // of the packet (to trace the packet)
  int src; // of the packet
  int src_agent; // Equivalent to port number
  int dst;
  int dst_agent; // Equivalent to port number
  int size;
  double send_time;
  int process_count; // How many nodes will process this packet

  static int pkt_id_gen;

  Packet (void);
  virtual ~Packet (void);
};

#endif


