/*
 * File: rt.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */

#ifndef _RT_H_
#define _RT_H_

/* For node i, the next hop is next_hop_id[i] */
/* If valid is false, then there is no known next hop path */

enum RoutingType {

  ROUTE_ORACLE,
  ROUTE_ORACLE_TS,
  ROUTE_NULL
};

class Node;

class RoutingTable {

public:
  Node *n;
  RoutingType t;
  
public:
  RoutingTable (void) {t = ROUTE_NULL;};
  RoutingTable (RoutingType T, Node *N) {t = T; n = N;};

  virtual int get_next_hop_id (int dst) = 0;
  virtual double get_path_cost (int dst) = 0;
};

#endif
