/**************************************************
 *
  File: bse-agent.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  NICE implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _BSE_AGENT_H_
#define _BSE_AGENT_H_

// #include <agent.h>
#include "common-agent.h"
#include "layerinfo.h"
#include "nicenode.h"

class bseAgent : public commonAgent {

public :

  // agent id and node id are in the agent class
 
  LayerInfo * top_layer;

  // statistics
  double m_last_change;

  ~bseAgent (void) { if (top_layer != NULL) delete top_layer; };

  void start (void);
  void stop (void);
  void init (int Id, int Index, Node *N);

  void specific_rx_pkt_handler (Packet *p);  

  void handle_cluster_refresh_msg_timeout (void);
  void handle_cluster_refresh_check_timeout (void);

private :

  void reset_layer_info (int top_lid);
  void fill_highest_layer_info (AppPacket *p);

  void handle_join_query (AppPacket *p);
  void handle_cluster_refresh (AppPacket *p);
  void handle_data_packet (AppPacket *ap);
  void handle_cluster_merge (AppPacket * ap);

  void split_top_layer_using_two_partition (void);

  void send_cluster_remove (LayerInfo *l);

  void send_top_layer_cluster_refresh (LayerAgentInfo * ignore_agent);

  void log_cluster_change_info(void);
  void display_top_layer_info (void);
  bool self_check (LayerAgentInfo * la);

};
#endif
