/**************************************************
 *
  File: nicenode.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  NICE implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _NICENODE_H_
#define _NICENODE_H_

#include <node.h>

class NiceNode : public Node {

public:

  int m_data_packet_count;
  int m_control_packet_count;
  int m_control_byte_count;

  int * m_per_node_data_pkt_count;

public:

  NiceNode(void);
  ~NiceNode(void);

  void specific_tx_pkt (Packet *p, int dst);
  void specific_rx_pkt_handler (Packet *p, bool is_src);

  int get_app_packet_size (Packet *p);

  void display_on_stop_simulation (void);
};

#endif
