/**************************************************
 *
  File: coop-agent.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  UNI implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _COOP_AGENT_H_
#define _COOP_AGENT_H_

#include <agent.h>
#include <timer.h>

class coopAgent;

/*
class SourceGroupTimer : public Timer {

public :
  coopAgent *ca;

  SourceGroupTimer (void) : Timer () { ca = NULL;};
  SourceGroupTimer (coopAgent *CA) : Timer () { ca = CA;};
  void EventHandler (void);
};
*/

class coopAgent : public Agent {

private :


  // SourceGroupTimer sgt;
  int m_data_seq_no;

public :

  AgentInfo bse; // The bootstrap entity

  bool is_source;
  LinkedList<AgentInfo *, int> m_member_list;

  coopAgent (void);
  ~coopAgent (void);
  void start (void);
  void stop (void);
  void init (int Id, int Index, Node *N);

  inline void set_bse_agent(int agent_id, int node_id) { bse.agent_id = agent_id; bse.node_id = node_id; };
  void specific_rx_pkt_handler (Packet *p);
  void specific_send_data_pkt (void);


private:

  void handle_source_update (AppPacket *ap);
  void handle_data_packet (AppPacket *ap);

  void remove_member_list (void);

};

#endif
